diff --git a/src/core/wee-hook.c b/src/core/wee-hook.c
index 6b0dc0a..3c0952c 100644
--- a/src/core/wee-hook.c
+++ b/src/core/wee-hook.c
@@ -1231,7 +1231,7 @@ hook_process_child (struct t_hook *hook_process)
 
 void
 hook_process_child_read (struct t_hook *hook_process, int fd,
-                         int stdout, struct t_hook **hook_fd)
+                         int ztdout, struct t_hook **hook_fd)
 {
     char buffer[4096];
     int num_read;
@@ -1244,8 +1244,8 @@ hook_process_child_read (struct t_hook *hook_process, int fd,
             (hook_process->callback_data,
              HOOK_PROCESS(hook_process, command),
              WEECHAT_HOOK_PROCESS_RUNNING,
-             (stdout) ? buffer : NULL,
-             (stdout) ? NULL : buffer);
+             (ztdout) ? buffer : NULL,
+             (ztdout) ? NULL : buffer);
     }
     else if (num_read == 0)
     {
diff --git a/src/core/wee-hook.h b/src/core/wee-hook.h
index 2827d3c..75f639c 100644
--- a/src/core/wee-hook.h
+++ b/src/core/wee-hook.h
@@ -160,8 +160,8 @@ struct t_hook_fd
 /* hook process */
 
 typedef int (t_hook_callback_process)(void *data, const char *command,
-                                      int return_code, const char *stdout,
-                                      const char *stderr);
+                                      int return_code, const char *ztdout,
+                                      const char *ztderr);
 
 struct t_hook_process
 {
diff --git a/src/plugins/scripts/lua/weechat-lua-api.c b/src/plugins/scripts/lua/weechat-lua-api.c
index 6669427..c8e125d 100644
--- a/src/plugins/scripts/lua/weechat-lua-api.c
+++ b/src/plugins/scripts/lua/weechat-lua-api.c
@@ -3432,7 +3432,7 @@ weechat_lua_api_hook_fd (lua_State *L)
 int
 weechat_lua_api_hook_process_cb (void *data,
                                  const char *command, int return_code,
-                                 const char *stdout, const char *stderr)
+                                 const char *ztdout, const char *ztderr)
 {
     struct t_script_callback *script_callback;
     char *lua_argv[6], str_rc[32], empty_arg[1] = { '\0' };
@@ -3447,8 +3447,8 @@ weechat_lua_api_hook_process_cb (void *data,
         lua_argv[0] = (script_callback->data) ? script_callback->data : empty_arg;
         lua_argv[1] = (command) ? (char *)command : empty_arg;
         lua_argv[2] = str_rc;
-        lua_argv[3] = (stdout) ? (char *)stdout : empty_arg;
-        lua_argv[4] = (stderr) ? (char *)stderr : empty_arg;
+        lua_argv[3] = (ztdout) ? (char *)ztdout : empty_arg;
+        lua_argv[4] = (ztderr) ? (char *)ztderr : empty_arg;
         lua_argv[5] = NULL;
         
         rc = (int *) weechat_lua_exec (script_callback->script,
diff --git a/src/plugins/scripts/perl/weechat-perl-api.c b/src/plugins/scripts/perl/weechat-perl-api.c
index cfe30e4..a4c2931 100644
--- a/src/plugins/scripts/perl/weechat-perl-api.c
+++ b/src/plugins/scripts/perl/weechat-perl-api.c
@@ -2886,7 +2886,7 @@ static XS (XS_weechat_api_hook_fd)
 int
 weechat_perl_api_hook_process_cb (void *data,
                                   const char *command, int return_code,
-                                  const char *stdout, const char *stderr)
+                                  const char *ztdout, const char *ztderr)
 {
     struct t_script_callback *script_callback;
     char *perl_argv[6], str_rc[32], empty_arg[1] = { '\0' };
@@ -2901,8 +2901,8 @@ weechat_perl_api_hook_process_cb (void *data,
         perl_argv[0] = (script_callback->data) ? script_callback->data : empty_arg;
         perl_argv[1] = (command) ? (char *)command : empty_arg;
         perl_argv[2] = str_rc;
-        perl_argv[3] = (stdout) ? (char *)stdout : empty_arg;
-        perl_argv[4] = (stderr) ? (char *)stderr : empty_arg;
+        perl_argv[3] = (ztdout) ? (char *)ztdout : empty_arg;
+        perl_argv[4] = (ztderr) ? (char *)ztderr : empty_arg;
         perl_argv[5] = NULL;
         
         rc = (int *) weechat_perl_exec (script_callback->script,
diff --git a/src/plugins/scripts/python/weechat-python-api.c b/src/plugins/scripts/python/weechat-python-api.c
index 3034115..3e745c6 100644
--- a/src/plugins/scripts/python/weechat-python-api.c
+++ b/src/plugins/scripts/python/weechat-python-api.c
@@ -3050,7 +3050,7 @@ weechat_python_api_hook_fd (PyObject *self, PyObject *args)
 int
 weechat_python_api_hook_process_cb (void *data,
                                     const char *command, int return_code,
-                                    const char *stdout, const char *stderr)
+                                    const char *ztdout, const char *ztderr)
 {
     struct t_script_callback *script_callback;
     char *python_argv[6], str_rc[32], empty_arg[1] = { '\0' };
@@ -3065,8 +3065,8 @@ weechat_python_api_hook_process_cb (void *data,
         python_argv[0] = (script_callback->data) ? script_callback->data : empty_arg;
         python_argv[1] = (command) ? (char *)command : empty_arg;
         python_argv[2] = str_rc;
-        python_argv[3] = (stdout) ? (char *)stdout : empty_arg;
-        python_argv[4] = (stderr) ? (char *)stderr : empty_arg;
+        python_argv[3] = (ztdout) ? (char *)ztdout : empty_arg;
+        python_argv[4] = (ztderr) ? (char *)ztderr : empty_arg;
         python_argv[5] = NULL;
         
         rc = (int *) weechat_python_exec (script_callback->script,
diff --git a/src/plugins/scripts/ruby/weechat-ruby-api.c b/src/plugins/scripts/ruby/weechat-ruby-api.c
index 5eb325a..b8caa68 100644
--- a/src/plugins/scripts/ruby/weechat-ruby-api.c
+++ b/src/plugins/scripts/ruby/weechat-ruby-api.c
@@ -3524,7 +3524,7 @@ weechat_ruby_api_hook_fd (VALUE class, VALUE fd, VALUE read, VALUE write,
 int
 weechat_ruby_api_hook_process_cb (void *data,
                                   const char *command, int return_code,
-                                  const char *stdout, const char *stderr)
+                                  const char *ztdout, const char *ztderr)
 {
     struct t_script_callback *script_callback;
     char *ruby_argv[6], str_rc[32], empty_arg[1] = { '\0' };
@@ -3539,8 +3539,8 @@ weechat_ruby_api_hook_process_cb (void *data,
         ruby_argv[0] = (script_callback->data) ? script_callback->data : empty_arg;
         ruby_argv[1] = (command) ? (char *)command : empty_arg;
         ruby_argv[2] = str_rc;
-        ruby_argv[3] = (stdout) ? (char *)stdout : empty_arg;
-        ruby_argv[4] = (stderr) ? (char *)stderr : empty_arg;
+        ruby_argv[3] = (ztdout) ? (char *)ztdout : empty_arg;
+        ruby_argv[4] = (ztderr) ? (char *)ztderr : empty_arg;
         ruby_argv[5] = NULL;
         
         rc = (int *) weechat_ruby_exec (script_callback->script,
diff --git a/src/plugins/scripts/script-api.c b/src/plugins/scripts/script-api.c
index 2eee671..85e05d5 100644
--- a/src/plugins/scripts/script-api.c
+++ b/src/plugins/scripts/script-api.c
@@ -887,8 +887,8 @@ script_api_hook_process (struct t_weechat_plugin *weechat_plugin,
                          int (*callback)(void *data,
                                          const char *command,
                                          int return_code,
-                                         const char *stdout,
-                                         const char *stderr),
+                                         const char *ztdout,
+                                         const char *ztderr),
                          const char *function,
                          const char *data)
 {
diff --git a/src/plugins/scripts/script-api.h b/src/plugins/scripts/script-api.h
index 8d4622c..0f2bef0 100644
--- a/src/plugins/scripts/script-api.h
+++ b/src/plugins/scripts/script-api.h
@@ -158,8 +158,8 @@ extern struct t_hook *script_api_hook_process (struct t_weechat_plugin *weechat_
                                                int (*callback)(void *data,
                                                                const char *command,
                                                                int return_code,
-                                                               const char *stdout,
-                                                               const char *stderr),
+                                                               const char *ztdout,
+                                                               const char *ztderr),
                                                const char *function,
                                                const char *data);
 extern struct t_hook *script_api_hook_connect (struct t_weechat_plugin *weechat_plugin,
diff --git a/src/plugins/scripts/tcl/weechat-tcl-api.c b/src/plugins/scripts/tcl/weechat-tcl-api.c
index 6ec6742..692ffce 100644
--- a/src/plugins/scripts/tcl/weechat-tcl-api.c
+++ b/src/plugins/scripts/tcl/weechat-tcl-api.c
@@ -3284,7 +3284,7 @@ weechat_tcl_api_hook_fd (ClientData clientData, Tcl_Interp *interp,
 int
 weechat_tcl_api_hook_process_cb (void *data,
                                  const char *command, int return_code,
-                                 const char *stdout, const char *stderr)
+                                 const char *ztdout, const char *ztderr)
 {
     struct t_script_callback *script_callback;
     char *tcl_argv[6], str_rc[32], empty_arg[1] = { '\0' };
@@ -3299,8 +3299,8 @@ weechat_tcl_api_hook_process_cb (void *data,
         tcl_argv[0] = (script_callback->data) ? script_callback->data : empty_arg;
         tcl_argv[1] = (command) ? (char *)command : empty_arg;
         tcl_argv[2] = str_rc;
-        tcl_argv[3] = (stdout) ? (char *)stdout : empty_arg;
-        tcl_argv[4] = (stderr) ? (char *)stderr : empty_arg;
+        tcl_argv[3] = (ztdout) ? (char *)ztdout : empty_arg;
+        tcl_argv[4] = (ztderr) ? (char *)ztderr : empty_arg;
         tcl_argv[5] = NULL;
         
         rc = (int *) weechat_tcl_exec (script_callback->script,
diff --git a/src/plugins/weechat-plugin.h b/src/plugins/weechat-plugin.h
index 0dab3ac..0599733 100644
--- a/src/plugins/weechat-plugin.h
+++ b/src/plugins/weechat-plugin.h
@@ -385,8 +385,8 @@ struct t_weechat_plugin
                                     int (*callback)(void *data,
                                                     const char *command,
                                                     int return_code,
-                                                    const char *stdout,
-                                                    const char *stderr),
+                                                    const char *ztdout,
+                                                    const char *ztderr),
                                     void *callback_data);
     struct t_hook *(*hook_connect) (struct t_weechat_plugin *plugin,
                                     const char *proxy,