Index: src/api/tcpip.c
===================================================================
RCS file: /sources/lwip/lwip/src/api/tcpip.c,v
retrieving revision 1.57
diff -u -0 -p -r1.57 tcpip.c
--- src/api/tcpip.c	29 Aug 2007 21:12:32 -0000	1.57
+++ src/api/tcpip.c	4 Sep 2007 17:07:04 -0000
@@ -546 +546 @@ tcpip_init(void (* initfunc)(void *), vo
-  sys_thread_new(tcpip_thread, NULL, TCPIP_THREAD_PRIO);
+  sys_thread_new(TCPIP_THREAD_NAME, tcpip_thread, NULL, TCPIP_THREAD_STACKSIZE, TCPIP_THREAD_PRIO);


Index: src/include/lwip/opt.h
===================================================================
RCS file: /sources/lwip/lwip/src/include/lwip/opt.h,v
retrieving revision 1.91
diff -u -0 -p -r1.91 opt.h
--- src/include/lwip/opt.h	4 Sep 2007 15:15:21 -0000	1.91
+++ src/include/lwip/opt.h	4 Sep 2007 17:06:37 -0000
@@ -744,0 +745,16 @@
+ * TCPIP_THREAD_NAME: The name assigned to the main tcpip thread.
+ */
+#ifndef TCPIP_THREAD_NAME
+#define TCPIP_THREAD_NAME              "tcpip_thread"
+#endif
+
+/**
+ * TCPIP_THREAD_STACKSIZE: The stack size used by the main tcpip thread.
+ * The stack size value itself is platform-dependent, but is passed to
+ * sys_thread_new() when the thread is created.
+ */
+#ifndef TCPIP_THREAD_STACKSIZE
+#define TCPIP_THREAD_STACKSIZE          0
+#endif
+
+/**
@@ -747 +763 @@
- * sys_thread_new() when tcpip_thread is created.
+ * sys_thread_new() when the thread is created.
@@ -753,0 +770,16 @@
+ * SLIPIF_THREAD_NAME: The name assigned to the slipif_loop thread.
+ */
+#ifndef SLIPIF_THREAD_NAME
+#define SLIPIF_THREAD_NAME             "slipif_loop"
+#endif
+
+/**
+ * SLIP_THREAD_STACKSIZE: The stack size used by the slipif_loop thread.
+ * The stack size value itself is platform-dependent, but is passed to
+ * sys_thread_new() when the thread is created.
+ */
+#ifndef SLIPIF_THREAD_STACKSIZE
+#define SLIPIF_THREAD_STACKSIZE         0
+#endif
+
+/**
@@ -756 +788 @@
- * sys_thread_new() when slipif_loop is created.
+ * sys_thread_new() when the thread is created.
@@ -762,0 +795,16 @@
+ * PPP_THREAD_NAME: The name assigned to the pppMain thread.
+ */
+#ifndef PPP_THREAD_NAME
+#define PPP_THREAD_NAME                "pppMain"
+#endif
+
+/**
+ * PPP_THREAD_STACKSIZE: The stack size used by the pppMain thread.
+ * The stack size value itself is platform-dependent, but is passed to
+ * sys_thread_new() when the thread is created.
+ */
+#ifndef PPP_THREAD_STACKSIZE
+#define PPP_THREAD_STACKSIZE            0
+#endif
+
+/**
@@ -765 +813 @@
- * sys_thread_new() when pppMain is created.
+ * sys_thread_new() when the thread is created.
@@ -772 +820,17 @@
- * DEFAULT_THREAD_PRIO: The priority assigned to the pppMain thread.
+ * DEFAULT_THREAD_NAME: The name assigned to any other lwIP thread.
+ */
+#ifndef DEFAULT_THREAD_NAME
+#define DEFAULT_THREAD_NAME            "lwIP"
+#endif
+
+/**
+ * DEFAULT_THREAD_STACKSIZE: The stack size used by any other lwIP thread.
+ * The stack size value itself is platform-dependent, but is passed to
+ * sys_thread_new() when the thread is created.
+ */
+#ifndef DEFAULT_THREAD_STACKSIZE
+#define DEFAULT_THREAD_STACKSIZE        0
+#endif
+
+/**
+ * DEFAULT_THREAD_PRIO: The priority assigned to any other lwIP thread.
@@ -774 +838 @@
- * sys_thread_new() when pppMain is created.
+ * sys_thread_new() when the thread is created.


Index: src/include/lwip/sys.h
===================================================================
RCS file: /sources/lwip/lwip/src/include/lwip/sys.h,v
retrieving revision 1.27
diff -u -0 -p -r1.27 sys.h
--- src/include/lwip/sys.h	22 May 2007 20:51:34 -0000	1.27
+++ src/include/lwip/sys.h	4 Sep 2007 17:06:51 -0000
@@ -65 +65 @@ struct sys_timeo {u8_t dummy;};
-#define sys_thread_new(t,a,p)
+#define sys_thread_new(n,t,a,s,p)
@@ -137 +137 @@ void sys_mbox_fetch(sys_mbox_t mbox, voi
-sys_thread_t sys_thread_new(void (* thread)(void *arg), void *arg, int prio);
+sys_thread_t sys_thread_new(char *name, void (* thread)(void *arg), void *arg, int stacksize, int prio);


Index: src/netif/slipif.c
===================================================================
RCS file: /sources/lwip/lwip/src/netif/slipif.c,v
retrieving revision 1.26
diff -u -0 -p -r1.26 slipif.c
--- src/netif/slipif.c	31 Aug 2007 10:14:09 -0000	1.26
+++ src/netif/slipif.c	4 Sep 2007 17:07:18 -0000
@@ -270 +270 @@ slipif_init(struct netif *netif)
-  sys_thread_new(slipif_loop, netif, SLIPIF_THREAD_PRIO);
+  sys_thread_new(SLIPIF_THREAD_NAME, slipif_loop, netif, SLIPIF_THREAD_STACKSIZE, SLIPIF_THREAD_PRIO);


Index: src/netif/ppp/ppp.c
===================================================================
RCS file: /sources/lwip/lwip/src/netif/ppp/ppp.c,v
retrieving revision 1.16
diff -u -0 -p -r1.16 ppp.c
--- src/netif/ppp/ppp.c	17 Aug 2007 22:15:24 -0000	1.16
+++ src/netif/ppp/ppp.c	4 Sep 2007 17:07:11 -0000
@@ -535 +535 @@ int pppOverSerialOpen(sio_fd_t fd, void 
-	sys_thread_new(pppMain, (void*)pd, PPP_THREAD_PRIO);
+	sys_thread_new(PPP_THREAD_NAME, pppMain, (void*)pd, PPP_THREAD_STACKSIZE, PPP_THREAD_PRIO);